Bug 23112 - SVG inside HTML with CSS transforms has redraw issues.
Summary: SVG inside HTML with CSS transforms has redraw issues.
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: SVG (show other bugs)
Version: 528+ (Nightly build)
Hardware: Macintosh OS X 10.5
: P2 Normal
Assignee: Nobody
URL:
Keywords:
Depends on: 25532
Blocks:
  Show dependency treegraph
 
Reported: 2009-01-04 20:11 PST by Simon Fraser (smfr)
Modified: 2009-05-05 06:49 PDT (History)
3 users (show)

See Also:


Attachments
Testcase (1.97 KB, text/xml)
2009-01-04 20:11 PST, Simon Fraser (smfr)
no flags Details
Update test case for SVG in CSS transforms (4.91 KB, patch)
2009-05-04 23:48 PDT, Eric Seidel (no email)
mjs: review+
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Simon Fraser (smfr) 2009-01-04 20:11:17 PST
An <svg> element inside an html hierarchy with CSS transforms fails to redraw correctly.
Comment 1 Simon Fraser (smfr) 2009-01-04 20:11:46 PST
Created attachment 26420 [details]
Testcase
Comment 2 Simon Fraser (smfr) 2009-01-29 11:08:28 PST
Here's what I think needs to happen:
1. SVG should avoid "absoluteTransform" computations everywhere. All bounding boxes and transforms should be relative to the SVGRoot.

2. There needs to be repaint hand-off at the SVG/HTML boundaries (i.e. SVGRoot and SVGForeignObject), so that the hosting render system can convert the repaint rects to the correct coordinates.

3. SVGForeignObject is going to need a RenderLayer (see also bug 23111, bug 23113), and RenderLayers need to be parented through SVG/HTML boundaries. I think we can avoid other RenderLayers inside SVG, but we'll need to put the accumulated transform from SVG content on the foreignObject's layer.
Comment 3 Eric Seidel (no email) 2009-04-28 17:12:01 PDT
This was fixed by http://trac.webkit.org/changeset/42950 bug 25431.

I should land your test case as a LayoutTest though.
Comment 4 Eric Seidel (no email) 2009-05-04 23:48:35 PDT
Created attachment 30012 [details]
Update test case for SVG in CSS transforms

 5 files changed, 74 insertions(+), 0 deletions(-)
Comment 5 Eric Seidel (no email) 2009-05-04 23:49:17 PDT
We currently fail the <text> section of this test, but pass all the rest.
Comment 6 Maciej Stachowiak 2009-05-05 06:30:45 PDT
Comment on attachment 30012 [details]
Update test case for SVG in CSS transforms

r=me
Comment 7 Eric Seidel (no email) 2009-05-05 06:49:27 PDT
http://trac.webkit.org/changeset/43234